#include <iostream>
#include <cmath>

using namespace std;

long long zbir = 0;

void funkcija(int t[], int k, int velicina){

    if(k==0){
        for(int i=0;i<velicina;i++){
            zbir += t[i];
        }
    }else{
        for(int i=0;i<velicina;i++){
            for(int j=i;j<velicina;j++){
                int temp[j-i+1];
                for(int ii=0;ii<=j-i;ii++){
                    temp[ii] = t[i+ii];
                }
                funkcija(temp, k-1, j-i+1);
            }
        }
    }
}

int main()
{
    int n, k;

    cin >> n >> k;

    int a[n];

    for(int i=0;i<n;i++){
        cin >> a[i];
    }

    funkcija(a, k, sizeof(a)/sizeof(a[0]));

    zbir %= 1000000000 + 7;
    cout << zbir;

    return 0;
}